 /*****************************************************************************
 * Copyright (c) 2004 PureChaos, All Rights Reserved.
 * z̃vCdc[(ReplayAssort)
 *
 * Version History
 * Date                Version  Programmer
 * ----------  -------  -------  ------------------------------------------
 * 2005/01/09         0.0.0    R
 *
 ****************************************************************************/

import java.awt.* ;
import java.awt.event.* ;
import javax.swing.* ;
import java.util.*;
import java.io.*;
import java.net.*;
import org.apache.commons.io.CopyUtils;

public class ReplayAssort extends JFrame{
    private Vector replay = new Vector();
    private Vector orgReplay = new Vector();
    private JScrollPane listScroll = null;
    private JTable      listTable = null;

    private JPanel mainPanel = new JPanel();
    private JPanel listPanel   = new JPanel();
    private JTextField inputFolder  = new JTextField(20);
    private JTextField outputFolder = new JTextField(20);
    private JComboBox p1CharBox = null;
    private JComboBox p1ColorBox = null;
    private JComboBox p2CharBox = null;
    private JComboBox p2ColorBox = null;
    private JCheckBox gunmaCheckBox = null;


    public ReplayAssort(){
        super("ReplayAssort");
        this.setBounds( 30, 0, 100, 200);
        
        Container c = getContentPane();
        mainPanel = new JPanel();
        //mainPanel.setPreferredSize(new Dimension(600, 300));
        mainPanel.setLayout(new GridLayout(1,2,0,0));
        c.add("Center", mainPanel);

        listPanel = new JPanel();
        listPanel.setPreferredSize(new Dimension(300, 400));
        mainPanel.add("Center", listPanel);
        
        JPanel uperPanel   = new JPanel();
        uperPanel.setLayout(new GridLayout(4,1,0,0));
        mainPanel.add("North", uperPanel);
        JPanel inputPanel  = new JPanel();

        //inputPanel.add(inputFolder);
        //outputPanel.add(outputFolder);
        uperPanel.add(inputPanel);

        
        JButton loadButton = new JButton("tH_烊vCǂݍ");
        inputPanel.add(loadButton);

        JPanel outputPanel = new JPanel();
        outputPanel.setLayout(new GridLayout(2,1,0,0));
        
        JButton copyButton = new JButton("IvCRs[");
        JPanel outputPanelB = new JPanel();
        outputPanelB.add(copyButton);
        
        gunmaCheckBox = new JCheckBox("vCt@CQn`ɕύX");
        JPanel outputPanelA = new JPanel();
        outputPanelA.add(gunmaCheckBox);
        
        outputPanel.add(outputPanelA);
        outputPanel.add(outputPanelB);
        uperPanel.add(outputPanel);
        
        
        

        loadButton.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                loadDialog();

            }
        });

        copyButton.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                copyDialog();
            }
        });
/************************************************************/
        JPanel maskPanel = new JPanel();
        uperPanel.add(maskPanel);
        
        p1CharBox = new JComboBox();
        p1CharBox.addItem("S");
        p1CharBox.addItem("얲");
        p1CharBox.addItem("");
        p1CharBox.addItem("");
        p1CharBox.addItem("AX");
        p1CharBox.addItem("p`[");
        p1CharBox.addItem("d");
        p1CharBox.addItem("~A");
        p1CharBox.addItem("HXq");
        p1CharBox.addItem("");
        p1CharBox.addItem("");
        
        p1ColorBox = new JComboBox();
        p1ColorBox.addItem("S");
        p1ColorBox.addItem("1P");
        p1ColorBox.addItem("2P");
        p1ColorBox.addItem("3P");
        p1ColorBox.addItem("4P");
        p1ColorBox.addItem("5P");
        p1ColorBox.addItem("6P");
        
        p2CharBox = new JComboBox();
        p2CharBox.addItem("S");
        p2CharBox.addItem("얲");
        p2CharBox.addItem("");
        p2CharBox.addItem("");
        p2CharBox.addItem("AX");
        p2CharBox.addItem("p`[");
        p2CharBox.addItem("d");
        p2CharBox.addItem("~A");
        p2CharBox.addItem("HXq");
        p2CharBox.addItem("");
        p2CharBox.addItem("");
        
        p2ColorBox = new JComboBox();
        p2ColorBox.addItem("S");
        p2ColorBox.addItem("1P");
        p2ColorBox.addItem("2P");
        p2ColorBox.addItem("3P");
        p2ColorBox.addItem("4P");
        p2ColorBox.addItem("5P");
        p2ColorBox.addItem("6P");
        
        maskPanel.add(p1CharBox);
        //maskPanel.add(p1ColorBox);
        maskPanel.add(new JLabel("VS"));
        maskPanel.add(p2CharBox);
        //maskPanel.add(p2ColorBox);
        
        JButton maskButton = new JButton("");
        maskPanel.add(maskButton);

        maskButton.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                ReplayProperty.sortType = 0;
                search();
                paintTable();
            }
        });
/************************************************************/
        JPanel sortPanel = new JPanel();
        uperPanel.add(sortPanel);
        
        JButton p1Button = new JButton("1PŃ\[g");
        JButton p2Button = new JButton("2PŃ\[g");
        sortPanel.add(p1Button);
        sortPanel.add(p2Button);

        p1Button.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                ReplayProperty.sortType = 0;
                sort();
                paintTable();
            }
        });

        p2Button.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                ReplayProperty.sortType = 1;
                sort();
                paintTable();
            }
        });


        addWindowListener(new WindowAdapter(){
            public void windowClosing(WindowEvent ew){
                System.exit(0);
            }
        });
       
        paintTable();
        this.pack();
        this.setVisible(true); //\
    }



    public void search(){
        String p1Char  = (String)p1CharBox.getSelectedItem();
        String p1Color = (String)p1ColorBox.getSelectedItem();
        String p2Char  = (String)p2CharBox.getSelectedItem();
        String p2Color = (String)p2ColorBox.getSelectedItem();
        replay = new Vector();
            
        for(int i = 0; i < orgReplay.size(); i ++){
            ReplayProperty rp = (ReplayProperty)orgReplay.elementAt(i);

            boolean flag1 = false;
            if( (p1Char.equals("S")  || p1Char.equals(rp.p1Name) ) &&
                (p1Color.equals("S") || p1Color.equals(rp.p1Color+"P") ) &&
                (p2Char.equals("S")  || p2Char.equals(rp.p2Name) )&&
                (p2Color.equals("S") || p2Color.equals(rp.p2Color+"P") ) ){
                flag1 = true;
            }
            
            boolean flag2 = false;
            if( (p1Char.equals("S")  || p1Char.equals(rp.p2Name) ) &&
                (p1Color.equals("S") || p1Color.equals(rp.p2Color+"P") ) &&
                (p2Char.equals("S")  || p2Char.equals(rp.p1Name) ) &&
                (p2Color.equals("S") || p2Color.equals(rp.p1Color+"P") ) ){
                flag2 = true;
            }
            
            if(flag1 || flag2){
                replay.add(rp);
            }
        }
    }

    public void sort(){
        TreeSet tree = new TreeSet();
        for(int i = 0; i < replay.size(); i ++){
            tree.add(replay.elementAt(i));
        }
        
        Vector newReplay = new Vector();
        newReplay.addAll(tree);
        replay = newReplay;
    }


    public void loadDialog(){
        JFileChooser fc = new JFileChooser();
        fc.setFileSelectionMode( JFileChooser.DIRECTORIES_ONLY );
        int result = fc.showDialog(this, "ǂݍ");
        if (result == JFileChooser.APPROVE_OPTION) {
            File inputFile = fc.getSelectedFile();
            if(inputFile.exists()){
                orgReplay = new Vector();
                replay = new Vector();
                load(inputFile);
                paintTable();
            }
        }
                
    }
    
    public void load(File base){
        File files[] = base.listFiles();
        for(int i = 0; i < files.length; i ++){
            if(files[i].isDirectory()){
                System.out.println(files[i].getPath() + " ");
                load(files[i]);
            }
            else{
                if(files[i].getName().endsWith(".rep")){
                    ReplayProperty rp = new ReplayProperty();
                    rp.setProperty(files[i]);
                    orgReplay.add(rp);
                    replay.add(rp);
                }
            }
            
        }
    }

    public void copyDialog(){
        JFileChooser fc = new JFileChooser();
        fc.setFileSelectionMode( JFileChooser.DIRECTORIES_ONLY );
        int result = fc.showDialog(this, "Rs[");
        if (result == JFileChooser.APPROVE_OPTION) {
            if(listTable != null){
                File outputFile = fc.getSelectedFile();
                outputFile.mkdirs();
                int[] rows = listTable.getSelectedRows();
                for(int i = 0; i < rows.length; i ++){
                    String space = "";
                    if(i < 10) space = "00";
                    else if(i < 100) space = "0";
                    
                    ReplayProperty rp = (ReplayProperty)replay.elementAt(rows[i]);
                    String fileName = outputFile.getPath() + "/replay" + space + i + ".rep";
                    fileCopy(rp.filePath  +"/"+  rp.fileName , fileName);
                    
                    
                    if(gunmaCheckBox.isSelected() == true){
                        convertName(fileName, convertGunma(rp.p1Name) + 
                                    "vs" + convertGunma(rp.p2Name));
                                    System.out.println("gunma");
                    }
                }
            }
        }
    }


    public void paintTable(){
        listPanel.setLayout(new BorderLayout());
    
        String data[][] = new String[replay.size()][3];
        String columnNames[] = new String[3];
        
        
        columnNames[0] = "vC[P";
        columnNames[1] = "vC[Q";
        columnNames[2] = "vC";
        
        for(int i = 0; i < replay.size(); i ++){
            ReplayProperty rp = (ReplayProperty)replay.elementAt(i);
            data[i][0] = rp.p1Name ;//+ "(" + rp.p1Color + "P)";
            data[i][1] = rp.p2Name ;//+ "(" + rp.p2Color + "P)";
            data[i][2] = rp.replayName;
        }
        if(listScroll != null)
            listPanel.remove(listScroll);
        listTable = new JTable((Object[][])data, columnNames);
        listScroll = new JScrollPane(listTable);
        listTable.setPreferredScrollableViewportSize(listPanel.getSize());
        listTable.setVisible(true);
        listPanel.add(listScroll, BorderLayout.CENTER);
        listPanel.doLayout();
    }

    public String convertGunma(String charName){
        String gunmaName = "";
        if(charName.equals("얲")) gunmaName = "REI";
        if(charName.equals("")) gunmaName = "MAR";
        if(charName.equals("")) gunmaName = "SAK";
        if(charName.equals("AX")) gunmaName = "ALI";
        if(charName.equals("p`[")) gunmaName = "PAT";
        if(charName.equals("d")) gunmaName = "YOU";
        if(charName.equals("~A")) gunmaName = "REM";
        if(charName.equals("HXq")) gunmaName = "YUY";
        if(charName.equals("")) gunmaName = "YUK";
        if(charName.equals("")) gunmaName = "SUI";
        return gunmaName;
    }

    public void convertName(String fileName , String name){
        try{
            FileInputStream input=new FileInputStream(fileName);
            byte buf[]=new byte[input.available()];
            input.read(buf);
            input.close();
            for(int i = 0; i < 8; i ++){
                if(i < name.length() ){
                    buf[i] = charToByte(name.charAt(i));
                }
                else{
                    buf[i] = 91;
                }
            }
            FileOutputStream output=new FileOutputStream(fileName);
            output.write(buf);
            output.close();
        }
        catch(Exception e){
        }
    }

    public byte charToByte(char c){
        byte b = 91;
        if(0 <= c-'A' && c-'A' < 26 ){
            b = (byte)(c - 'A');
        }
        else if(0 <= c-'a' && c-'a' < 26 ){
            b = (byte)(c-'a' + 26);
        }
        else if(0 <= c-'0' && c-'0' < 10 ){
            b = (byte)(c-'0' + 52);
        }
        switch(c){
            case '+': b= (byte)62; break;
            case '-': b= (byte)63; break;
            case '/': b= (byte)64; break;
            case '*': b= (byte)65; break;
            case '=': b= (byte)66; break;
            case '%': b= (byte)67; break;
            case '#': b= (byte)68; break;
            case '!': b= (byte)69; break;
            case '?': b= (byte)70; break;
            case '.': b= (byte)71; break;
            case ',': b= (byte)72; break;
            case ':': b= (byte)73; break;
            case ';': b= (byte)74; break;
            case '_': b= (byte)75; break;
            case '@': b= (byte)76; break;
            case '$': b= (byte)77; break;
            case '(': b= (byte)78; break;
            case ')': b= (byte)79; break;
            case '{': b= (byte)80; break;
            case '}': b= (byte)81; break;
            case '[': b= (byte)82; break;
            case ']': b= (byte)83; break;
            case '<': b= (byte)84; break;
            case '>': b= (byte)85; break;
            case '&': b= (byte)86; break;
            case '\\': b= (byte)87; break;
            case '|': b= (byte)88; break;
            case '~': b= (byte)89; break;
            case '^': b= (byte)90; break;
            case ' ': b= (byte)91; break;
            default:               break;
        }
        return b;
    }

    public void fileCopy(String input, String output){
        try{
            FileInputStream in = new FileInputStream(input);
            FileOutputStream out = new FileOutputStream(output);
            CopyUtils.copy(in, out);
            in.close();
            out.close();
        } catch(Exception e){
        }
    }

    //`
    public void paint(Graphics gr){
        super.paint(gr);
    }
    
    public static void main(String[] args){
        

        ReplayAssort ra = new ReplayAssort();

    }
}


class ReplayProperty implements Comparable{
    public String p1Name;
    public int p1Color;
    public String p2Name;
    public int p2Color;
    public String fileName;
    public String filePath;
    public String replayName;
    public static int sortType = 0;
    
    public void setProperty(File file){
        try{
            FileInputStream input=new FileInputStream(file.getPath());
            //System.out.println(input.available());
            byte buf[]=new byte[64];
            input.read(buf);
            input.close();
            p1Name = getCharName(buf[10]);
            p2Name = getCharName(buf[48]);
            p1Color = 1;//(int)buf[8]  + 1;
            p2Color = 1;//(int)buf[10] + 1;
            
            byte name[]=new byte[8];
            for(int i = 0; i < 8; i ++){
                name[i] = byteToChar(buf[i]);
            }
            replayName = new String(name);
        }
        catch(Exception e){
        }
        fileName = file.getName();
        filePath = file.getParent();
    }
    
    public byte byteToChar(byte b){
        byte c = (byte)' ';
        if(0 <= b && b < 26 ){
            c = (byte)('A' + b);
        }
        else if(26 <= b && b < 52 ){
            c = (byte)('a' + b-26);
        }
        else if(52 <= b && b < 62 ){
            c = (byte)('0' + b-52);
        }
        switch(b){
            case 62: c= (byte)'+'; break;
            case 63: c= (byte)'-'; break;
            case 64: c= (byte)'/'; break;
            case 65: c= (byte)'*'; break;
            case 66: c= (byte)'='; break;
            case 67: c= (byte)'%'; break;
            case 68: c= (byte)'#'; break;
            case 69: c= (byte)'!'; break;
            case 70: c= (byte)'?'; break;
            case 71: c= (byte)'.'; break;
            case 72: c= (byte)','; break;
            case 73: c= (byte)':'; break;
            case 74: c= (byte)';'; break;
            case 75: c= (byte)'_'; break;
            case 76: c= (byte)'@'; break;
            case 77: c= (byte)'$'; break;
            case 78: c= (byte)'('; break;
            case 79: c= (byte)')'; break;
            case 80: c= (byte)'{'; break;
            case 81: c= (byte)'}'; break;
            case 82: c= (byte)'['; break;
            case 83: c= (byte)']'; break;
            case 84: c= (byte)'<'; break;
            case 85: c= (byte)'>'; break;
            case 86: c= (byte)'&'; break;
            case 87: c= (byte)'\\'; break;
            case 88: c= (byte)'|'; break;
            case 89: c= (byte)'~'; break;
            case 90: c= (byte)'^'; break;
            case 91: c= (byte)' '; break;
            default:               break;
        }
        return c;
    }
    
    public String getCharName(byte charIndex){
        String name = "H";
        switch(charIndex){
            case 0:name  = "얲";break;
            case 1:name  = "";break;
            case 2:name  = "";break;
            case 3:name  = "AX";break;
            case 4:name  = "p`[";break;
            case 5:name  = "d";break;
            case 6:name  = "~A";break;
            case 7:name  = "HXq";break;
            case 8:name  = "";break;
            case 9:name  = "";break;
            default:               break;
        }
        return name;
    }
    
   /**
    * IuWFNgr܂B
    * ̊֐equalsƓł͂܂B
    * @param o rΏۂ̃IuWFNg
    * @return r
    */
    public int compareTo(Object o) {
        ReplayProperty rp = (ReplayProperty)o;
        int ans = 1;
        if(sortType == 0){
            ans = (this.p1Name).compareTo(rp.p1Name);
            if(ans == 0){
                ans = this.p1Color - rp.p1Color;
                if(ans == 0){
                    ans = (this.p2Name).compareTo(rp.p2Name);
                    if(ans == 0){
                        ans = this.p2Color - rp.p2Color;
                        if(ans == 0){
                            ans = 1;
                        }
                    }
                    
                }
            }
        }
        else if(sortType == 1){
            ans = (this.p2Name).compareTo(rp.p2Name);
            if(ans == 0){
                ans = this.p2Color - rp.p2Color;
                if(ans == 0){
                    ans = (this.p1Name).compareTo(rp.p1Name);
                    if(ans == 0){
                        ans = this.p1Color - rp.p1Color;
                        if(ans == 0){
                            ans = 1;
                        }
                    }
                    
                }
            }
        }
        
        return ans;
    }
}

/*
0:
1:
2:
3:^
4:
5:
6:
7:݂
8:x
9:S
A:
B:Y
C:hby
D:
E:薢
F:

12:EX݂
13:
14:T
15:
17:ϗ




*/